searchData={"items":[{"type":"module","title":"Common.Payload","doc":"Module oriented to common functions for working with payloads","ref":"Common.Payload.html"},{"type":"function","title":"Common.Payload.extract_data/4","doc":"Extract the `value` of the key defined in the map","ref":"Common.Payload.html#extract_data/4"},{"type":"function","title":"Parameters: - Common.Payload.extract_data/4","doc":"- payload: Map. Container of the information ( ) that is required.\n\n    - tag: String. Key to search within the map.\n\n    - list: List of String. List of tags to search in depth, by structure chaining.\n\n    - default_value: t(). Default value, in case it cannot be found. If not defined, it takes value nil.","ref":"Common.Payload.html#extract_data/4-parameters"},{"type":"function","title":"Return: - Common.Payload.extract_data/4","doc":"- t() | nil. If the defined labels are correct, it returns the desired value; otherwise nil.","ref":"Common.Payload.html#extract_data/4-return"},{"type":"function","title":"Common.Payload.extract_with_format/3","doc":"Extract the information and attach it to the defined map. If it does not appear, it gives the default value in each case.\n\n ###Parameters:\n\n    - payload_: Map. Payload.\n\n    - attr_list. List of InfoAttr. Fields to search for in the payload.\n\n    - eliminate_null_value: Boolean. Indicates if you want to eliminate fields with null values.","ref":"Common.Payload.html#extract_with_format/3"},{"type":"function","title":"Return: - Common.Payload.extract_with_format/3","doc":"- list of {attr.id, values_extracted_from_the_payload} | empty list","ref":"Common.Payload.html#extract_with_format/3-return"},{"type":"function","title":"Common.Payload.reduce_by/2","doc":"Group the maps with equal value in a certain field","ref":"Common.Payload.html#reduce_by/2"},{"type":"function","title":"Parameters: - Common.Payload.reduce_by/2","doc":"- list: List of map. Data.\n\n    - fields: Set of fields to set the identifier of each set. The identifier is the concatenation of each one, and the character '_'.","ref":"Common.Payload.html#reduce_by/2-parameters"},{"type":"function","title":"Return: - Common.Payload.reduce_by/2","doc":"- {A, B} where\n\n        A Map where values is a list of values of `list` such that they share the same value in the defined field\n\n        B List of t() coincides with A.key()","ref":"Common.Payload.html#reduce_by/2-return"},{"type":"module","title":"Common.Table","doc":"Module oriented to common functions for working with tables","ref":"Common.Table.html"},{"type":"function","title":"Common.Table.get_stored_values_in_bigquery/4","doc":"Obtains the values registered in Bigquery, associated with a set of record identifiers","ref":"Common.Table.html#get_stored_values_in_bigquery/4"},{"type":"function","title":"Parameters: - Common.Table.get_stored_values_in_bigquery/4","doc":"- pid: Process. Process connecting Elixir and ODBC.\n\n    - attr_list: List of Tools.Struct.InfoAttr. Attributes to carry the query response to the defined data type.\n\n    - ids: List of Tools.Struct.InfoAttr. Attributes that will be used to differentiate the sets of records that share the same identifiers.\n\n    - statement: String. Statement to get the records from the database in Bigquery.","ref":"Common.Table.html#get_stored_values_in_bigquery/4-parameters"},{"type":"function","title":"Return: - Common.Table.get_stored_values_in_bigquery/4","doc":"- Exception | Map, where the key contains the values of `keys` and the values are the data that Bigquery has associated with the record with that identifier","ref":"Common.Table.html#get_stored_values_in_bigquery/4-return"},{"type":"function","title":"Common.Table.is_attr?/2","doc":"Checks if the specified name matches any column","ref":"Common.Table.html#is_attr?/2"},{"type":"function","title":"Parameter: - Common.Table.is_attr?/2","doc":"- table: Atom. Table name. It is assumed that this has implemented the function attr_list/0 -> List(Struct.InfoAttr)\n\n    - name: Atom | String. Name of the column to check.","ref":"Common.Table.html#is_attr?/2-parameter"},{"type":"function","title":"Return: - Common.Table.is_attr?/2","doc":"- Boolean.","ref":"Common.Table.html#is_attr?/2-return"},{"type":"module","title":"Connection.ElasticSearch","doc":"Module oriented to the creation of queries to ElasticSearch","ref":"Connection.ElasticSearch.html"},{"type":"function","title":"Connection.ElasticSearch.get_from_nv/7","doc":"Returns all defined indices, contained in a closed range. Use a New Vehicles service.","ref":"Connection.ElasticSearch.html#get_from_nv/7"},{"type":"function","title":"Parameters: - Connection.ElasticSearch.get_from_nv/7","doc":"- url: String. URL of the service. It is assumed that the url contains 2 parameters to replace them: \" \",  .\n\n    - headers: List of tuple.\n\n    -index_for_range: String. Index to use to filter by range.\n\n    - start_value: String. Lower bound for filtering.\n\n    - end_value: String. Upper bound for filtering.\n\n    - index_to_return: List of string. List of indexed terms to return.","ref":"Connection.ElasticSearch.html#get_from_nv/7-parameters"},{"type":"function","title":"Return: - Connection.ElasticSearch.get_from_nv/7","doc":"- {:ok, list of string} | {:error, string (message)}","ref":"Connection.ElasticSearch.html#get_from_nv/7-return"},{"type":"function","title":"Connection.ElasticSearch.get_from_nv/9","doc":"","ref":"Connection.ElasticSearch.html#get_from_nv/9"},{"type":"function","title":"Connection.ElasticSearch.get_from_range/8","doc":"Returns all defined indices, contained in a closed range","ref":"Connection.ElasticSearch.html#get_from_range/8"},{"type":"function","title":"Parameters: - Connection.ElasticSearch.get_from_range/8","doc":"- url: String. URL of the service. It is assumed that the url contains 2 parameters to replace them: \" \",  .\n\n    - headers: List of tuple.\n\n    - type_documentary: String. Documentary type.\n\n    - mode: String. ElasticSearch access mode. Default value: \"_search\".\n\n    - init_date: String. Range start date is included. Expected format `YYYY-MM-DDThh:mm:ss.mZ`.\n\n    - end_date: String. Range end date is included. Expected format `YYYY-MM-DDThh:mm:ss.mZ`.\n\n    - index_for_range: String. Index that allows searching by range. It must be considered in the set of ElasticSearch indexes.\n\n    - index_to_return: String. Index that will be returned for each document, according to what ElasticSearch returns.","ref":"Connection.ElasticSearch.html#get_from_range/8-parameters"},{"type":"function","title":"Returns: - Connection.ElasticSearch.get_from_range/8","doc":"- Exception | List of the values of the `index_to_return` index, in each document.","ref":"Connection.ElasticSearch.html#get_from_range/8-returns"},{"type":"function","title":"Connection.ElasticSearch.get_indexed_indices/4","doc":"Returns the indexed indices for `path`","ref":"Connection.ElasticSearch.html#get_indexed_indices/4"},{"type":"function","title":"Parameters: - Connection.ElasticSearch.get_indexed_indices/4","doc":"- url: String. URL of the service. It is assumed that the url contains 2 parameters to replace them: \" \",  .\n\n    - headers: List of tuple.\n\n    - type_documentary: String. Documentary type.\n\n    - mode: String. ElasticSearch access mode. Default value `_search`.","ref":"Connection.ElasticSearch.html#get_indexed_indices/4-parameters"},{"type":"function","title":"Return: - Connection.ElasticSearch.get_indexed_indices/4","doc":"- List of Atom | Exception","ref":"Connection.ElasticSearch.html#get_indexed_indices/4-return"},{"type":"function","title":"Connection.ElasticSearch.mode/0","doc":"Returns the ElasticSearch keyword to indicate how it will be used. It will only be consulted.","ref":"Connection.ElasticSearch.html#mode/0"},{"type":"function","title":"Return: - Connection.ElasticSearch.mode/0","doc":"- String. ElasticSearch reserved word.","ref":"Connection.ElasticSearch.html#mode/0-return"},{"type":"module","title":"Connection.Http","doc":"Module for working with the HTTP protocol","ref":"Connection.Http.html"},{"type":"function","title":"Connection.Http.get/4","doc":"GET request","ref":"Connection.Http.html#get/4"},{"type":"function","title":"Parameters: - Connection.Http.get/4","doc":"- url: String.\n\n    - headers: List of tuple.\n\n    - timeout: Integer.\n\n    - recv_timeout: Integer.","ref":"Connection.Http.html#get/4-parameters"},{"type":"function","title":"Return: - Connection.Http.get/4","doc":"- {:ok, data} | {:error, data}","ref":"Connection.Http.html#get/4-return"},{"type":"function","title":"Connection.Http.post/4","doc":"POST request","ref":"Connection.Http.html#post/4"},{"type":"function","title":"Parameters: - Connection.Http.post/4","doc":"- body: String.\n\n    - url: String.\n\n    - headers: List of tuple.\n\n    - recv_timeout: Integer.","ref":"Connection.Http.html#post/4-parameters"},{"type":"function","title":"Return: - Connection.Http.post/4","doc":"- {:ok, data} | {:error, data}","ref":"Connection.Http.html#post/4-return"},{"type":"module","title":"Connection.NodeService","doc":"Work with Node Service","ref":"Connection.NodeService.html"},{"type":"function","title":"Connection.NodeService.get_details/4","doc":"Returns details of a node","ref":"Connection.NodeService.html#get_details/4"},{"type":"function","title":"Parameter: - Connection.NodeService.get_details/4","doc":"- node: String. Node/document identifier.\n\n    - url: String. URL of the service. It is assumed that the url contains 2 parameters to replace them:  ,  .\n\n    - node: String. Node/document identifier.\n\n    - headers\n\n    - ticket: Possible values:\n\n        - {String, String, String, String}. Corresponds to information necessary to obtain the ticket. The order is: url, headers, username, password.\n\n        - String: Ticket.","ref":"Connection.NodeService.html#get_details/4-parameter"},{"type":"function","title":"Return: - Connection.NodeService.get_details/4","doc":"-  {:ok, details} | {:error, message} | Exception","ref":"Connection.NodeService.html#get_details/4-return"},{"type":"module","title":"Connection.Odbc","doc":"Module for working with the ODBC library. It frees you from having to know how Erlang's :odbc library works.","ref":"Connection.Odbc.html"},{"type":"function","title":"Connection.Odbc.connect/1","doc":"Establishes the connection to Data Source","ref":"Connection.Odbc.html#connect/1"},{"type":"function","title":"Parameter: - Connection.Odbc.connect/1","doc":"- data_source: List. Data source information.","ref":"Connection.Odbc.html#connect/1-parameter"},{"type":"function","title":"Return: - Connection.Odbc.connect/1","doc":"- PID | Exception. If the connection can be established with the parameters defined in the configuration files, process identifier is returned. Otherwise, it throws an exception with the error.","ref":"Connection.Odbc.html#connect/1-return"},{"type":"function","title":"Connection.Odbc.delete/2","doc":"Delete rows from the specified table","ref":"Connection.Odbc.html#delete/2"},{"type":"function","title":"Parameters: - Connection.Odbc.delete/2","doc":"- pid: Process. Process connecting Elixir and ODBC.\n\n    - statement: String. SQL Statement.","ref":"Connection.Odbc.html#delete/2-parameters"},{"type":"function","title":"Return: - Connection.Odbc.delete/2","doc":"- Exception | {:updated, n} where n is the number of records deleted","ref":"Connection.Odbc.html#delete/2-return"},{"type":"function","title":"Connection.Odbc.get_uuid/1","doc":"Genera un UUID","ref":"Connection.Odbc.html#get_uuid/1"},{"type":"function","title":"Parameter: - Connection.Odbc.get_uuid/1","doc":"- pid: Process.","ref":"Connection.Odbc.html#get_uuid/1-parameter"},{"type":"function","title":"Return: - Connection.Odbc.get_uuid/1","doc":"- string | Exception. If the query succeeds, it returns the UUID; otherwise, it raises an exception from `:odbc.sql_query/2` statement.","ref":"Connection.Odbc.html#get_uuid/1-return"},{"type":"function","title":"Connection.Odbc.insert/2","doc":"Inserts an object into the specified table","ref":"Connection.Odbc.html#insert/2"},{"type":"function","title":"Parameters: - Connection.Odbc.insert/2","doc":"- pid: Process. Process connecting Elixir and ODBC.\n\n    - statement: String. SQL Statement.","ref":"Connection.Odbc.html#insert/2-parameters"},{"type":"function","title":"Return: - Connection.Odbc.insert/2","doc":"- {:inserted, 1} | Exception","ref":"Connection.Odbc.html#insert/2-return"},{"type":"function","title":"Connection.Odbc.select/2","doc":"Create and execute an SQL statement of type `SELECT xx FROM x WHERE xxx. It is assumed that WHERE condition will only have the AND operator. Para","ref":"Connection.Odbc.html#select/2"},{"type":"function","title":"Parameters: - Connection.Odbc.select/2","doc":"- pid: Process. Process connecting Elixir and ODBC.\n\n    - statement: String. SQL Statement.","ref":"Connection.Odbc.html#select/2-parameters"},{"type":"function","title":"Return: - Connection.Odbc.select/2","doc":"- list of (list of tuples ({:atom, :string})) | Exception. Fields with null values are ignored.","ref":"Connection.Odbc.html#select/2-return"},{"type":"function","title":"Connection.Odbc.start/0","doc":"Start the ODBC application","ref":"Connection.Odbc.html#start/0"},{"type":"function","title":"Return: - Connection.Odbc.start/0","doc":"- :ok | exception. If the ODBC application has not been started or if it has already been started, return the atom. Otherwise, it throws an exception with the error.","ref":"Connection.Odbc.html#start/0-return"},{"type":"function","title":"Connection.Odbc.stop/0","doc":"Stop the ODBC application","ref":"Connection.Odbc.html#stop/0"},{"type":"function","title":"Return: - Connection.Odbc.stop/0","doc":"- :ok | exception. If the ODBC application has not been stopped or if it has already been stopped, return the atom. Otherwise, it throws an exception with the error.","ref":"Connection.Odbc.html#stop/0-return"},{"type":"function","title":"Connection.Odbc.update/2","doc":"Update an object into the specified table. It uses the `retry` decorator to retry the execution of the statement, in case of a concurrency error issued by BigQuery.","ref":"Connection.Odbc.html#update/2"},{"type":"function","title":"Parameters: - Connection.Odbc.update/2","doc":"- pid: Process. Process connecting Elixir and ODBC.\n\n    - statement: String. SQL Statement.","ref":"Connection.Odbc.html#update/2-parameters"},{"type":"function","title":"Return: - Connection.Odbc.update/2","doc":"- Exception | {:updated, n} where n is the number of records updated","ref":"Connection.Odbc.html#update/2-return"},{"type":"module","title":"Connection.Ticket","doc":"Module for working with access tickets","ref":"Connection.Ticket.html"},{"type":"function","title":"Connection.Ticket.get/4","doc":"Returns a valid ticket, depending on the user.","ref":"Connection.Ticket.html#get/4"},{"type":"function","title":"Parameters: - Connection.Ticket.get/4","doc":"- url: String. Url to consult. It is assumed that the url contains 2 parameters to replace them:  ,  .\n\n    - headers: List.\n\n    - username: String. Username.\n\n    - password: String. Password.\n\n    # - folder: String. Folder path to store the ticket.","ref":"Connection.Ticket.html#get/4-parameters"},{"type":"function","title":"Return: - Connection.Ticket.get/4","doc":"- {Atom, String} | Exception . The atom can take the values: ok or error. The string will be the ticket or the error message.","ref":"Connection.Ticket.html#get/4-return"},{"type":"function","title":"Connection.Ticket.refresh/5","doc":"Store a valid ticket, depending on the user. By default, the generic user is considered.","ref":"Connection.Ticket.html#refresh/5"},{"type":"function","title":"Parameters: - Connection.Ticket.refresh/5","doc":"- url: String. Url to consult. It is assumed that the url contains 2 parameters to replace them:  ,  .\n\n    - headers: List.\n\n    - username: String. Username.\n\n    - password: String. Password.\n\n    - folder: String. Folder path to store the ticket.","ref":"Connection.Ticket.html#refresh/5-parameters"},{"type":"function","title":"Return: - Connection.Ticket.refresh/5","doc":"- {:ok, ticket (String)} | {:error, error_msg (String)}","ref":"Connection.Ticket.html#refresh/5-return"},{"type":"module","title":"Connection.WorkflowService","doc":"Work with Workflow Service","ref":"Connection.WorkflowService.html"},{"type":"function","title":"Connection.WorkflowService.get_details/5","doc":"Returns the tasks associated with a record","ref":"Connection.WorkflowService.html#get_details/5"},{"type":"function","title":"Parameter: - Connection.WorkflowService.get_details/5","doc":"- url: String. URL of the service. It is assumed that the url contains 3 parameters to replace them:  ,  ,  .\n\n    - headers: List.\n\n    - type_documentary: String. Associated documentary type.\n\n    - contentref: String. Node/document identifier.\n\n    - ticket: String: Ticket.","ref":"Connection.WorkflowService.html#get_details/5-parameter"},{"type":"function","title":"Return: - Connection.WorkflowService.get_details/5","doc":"-  {:ok, details} | {:error, message} | Exception","ref":"Connection.WorkflowService.html#get_details/5-return"},{"type":"module","title":"Decoratorm","doc":"Module for the definition of internal decorators to the project","ref":"Decoratorm.html"},{"type":"macro","title":"Decoratorm.retry/0","doc":"","ref":"Decoratorm.html#retry/0"},{"type":"function","title":"Decoratorm.retry/2","doc":"Decorator function for retrying the call of the same function with the same parameters. Stops retries when it gets a value other than an exception or when the number of retries exceeds 10.","ref":"Decoratorm.html#retry/2"},{"type":"function","title":"Parameters: - Decoratorm.retry/2","doc":"- body:\n\n    - context:","ref":"Decoratorm.html#retry/2-parameters"},{"type":"function","title":"Return: - Decoratorm.retry/2","doc":"- t() | Exception","ref":"Decoratorm.html#retry/2-return"},{"type":"module","title":"EtlCore","doc":"Documentation for `EtlCore`.","ref":"EtlCore.html"},{"type":"function","title":"EtlCore.hello/0","doc":"Hello world.","ref":"EtlCore.html#hello/0"},{"type":"function","title":"Examples - EtlCore.hello/0","doc":"iex> EtlCore.hello()\n    :world","ref":"EtlCore.html#hello/0-examples"},{"type":"module","title":"File.FileManager","doc":"Tools for working with files","ref":"File.FileManager.html"},{"type":"function","title":"File.FileManager.load/1","doc":"Returns text stored in a file","ref":"File.FileManager.html#load/1"},{"type":"function","title":"Parameters: - File.FileManager.load/1","doc":"- path: String. File path.","ref":"File.FileManager.html#load/1-parameters"},{"type":"function","title":"Return: - File.FileManager.load/1","doc":"- String","ref":"File.FileManager.html#load/1-return"},{"type":"function","title":"File.FileManager.load_json/1","doc":"Load JSON into memory","ref":"File.FileManager.html#load_json/1"},{"type":"function","title":"Parameter: - File.FileManager.load_json/1","doc":"- filename: String or String List indicating the path of files in JSON format to read","ref":"File.FileManager.html#load_json/1-parameter"},{"type":"function","title":"Examples: - File.FileManager.load_json/1","doc":"eix> load_json(\"hello.json\")\n    {word: \"world\"}\n\n    eix> load_json([\"hello.txt\", \"foo.json\"])\n    [{word: \"world\"}, {key: \"bar\"}]\n\n    eix> filename = \"./file.txt\" # fake file path\n    eix> load_json(filename)\n    {:error, :enoent}\n\n    eix> filename = \"./file.txt\" # misdefined JSON file\n    eix> load_json(filename)\n    {:error, %Poison.Parse{...}}","ref":"File.FileManager.html#load_json/1-examples"},{"type":"function","title":"File.FileManager.save/2","doc":"Store in file, a text","ref":"File.FileManager.html#save/2"},{"type":"function","title":"Parameters: - File.FileManager.save/2","doc":"- text: String: Text to put in the document.\n\n    - path: String. File path.","ref":"File.FileManager.html#save/2-parameters"},{"type":"function","title":"File.FileManager.to_json_for_bigquery/2","doc":"Stores the data in a JSON file, a format supported for batch loading in BigQuery. The file name matches the time it was issued in UNIX format.\n\nParameters:\n\n    - data: List of map. Data.\n\n    - path: String. Local path to store the file.","ref":"File.FileManager.html#to_json_for_bigquery/2"},{"type":"function","title":"Return: - File.FileManager.to_json_for_bigquery/2","doc":"- :ok | Exception","ref":"File.FileManager.html#to_json_for_bigquery/2-return"},{"type":"module","title":"Genserver.Cleaning","doc":"Module/genserver oriented to delete the least updated rows in Bigquery. use the `timestamp` field","ref":"Genserver.Cleaning.html"},{"type":"function","title":"Genserver.Cleaning.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Genserver.Cleaning.html#child_spec/1"},{"type":"function","title":"Genserver.Cleaning.init/1","doc":"","ref":"Genserver.Cleaning.html#init/1"},{"type":"function","title":"Genserver.Cleaning.start_link/1","doc":"","ref":"Genserver.Cleaning.html#start_link/1"},{"type":"module","title":"Genserver.ForcedLoad","doc":"Genserver orientado a la carga de los datos","ref":"Genserver.ForcedLoad.html"},{"type":"function","title":"Genserver.ForcedLoad.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Genserver.ForcedLoad.html#child_spec/1"},{"type":"function","title":"Genserver.ForcedLoad.init/1","doc":"","ref":"Genserver.ForcedLoad.html#init/1"},{"type":"function","title":"Genserver.ForcedLoad.start_link/1","doc":"","ref":"Genserver.ForcedLoad.html#start_link/1"},{"type":"module","title":"Genserver.Monitor","doc":"Monitors registered GenServers and reports their status to a webhook.","ref":"Genserver.Monitor.html"},{"type":"function","title":"Genserver.Monitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Genserver.Monitor.html#child_spec/1"},{"type":"function","title":"Genserver.Monitor.init/1","doc":"","ref":"Genserver.Monitor.html#init/1"},{"type":"function","title":"Genserver.Monitor.monitor_system/3","doc":"","ref":"Genserver.Monitor.html#monitor_system/3"},{"type":"function","title":"Genserver.Monitor.register/2","doc":"","ref":"Genserver.Monitor.html#register/2"},{"type":"function","title":"Genserver.Monitor.start_link/1","doc":"","ref":"Genserver.Monitor.html#start_link/1"},{"type":"function","title":"Genserver.Monitor.unregister/1","doc":"","ref":"Genserver.Monitor.html#unregister/1"},{"type":"module","title":"Genserver.PostgresConsumer","doc":"Genserver oriented to consume from a table in a database in Postgres\n\nFor the correct operation, you must implement the Genserver.Protocols.PPostgresDb protocol","ref":"Genserver.PostgresConsumer.html"},{"type":"function","title":"Genserver.PostgresConsumer.handle_info/2","doc":"","ref":"Genserver.PostgresConsumer.html#handle_info/2"},{"type":"function","title":"Genserver.PostgresConsumer.init/1","doc":"","ref":"Genserver.PostgresConsumer.html#init/1"},{"type":"function","title":"Genserver.PostgresConsumer.start_link/1","doc":"","ref":"Genserver.PostgresConsumer.html#start_link/1"},{"type":"protocol","title":"Genserver.Protocols.PAutomaticClean","doc":"Definition of the method to be used for the automatic deletion of the repeated tuples, in the tables","ref":"Genserver.Protocols.PAutomaticClean.html"},{"type":"function","title":"Genserver.Protocols.PAutomaticClean.run/3","doc":"Removes from a certain table, the repeated rows\n\nTo add the definition of an automatic cleanup, add the definition for the private methods.","ref":"Genserver.Protocols.PAutomaticClean.html#run/3"},{"type":"function","title":"Parameters: - Genserver.Protocols.PAutomaticClean.run/3","doc":"- business: Atom. Define the business.\n\n    - pid: Process. Process connecting Elixir and ODBC.\n\n    - other_data: Tuple. Other data of interest.","ref":"Genserver.Protocols.PAutomaticClean.html#run/3-parameters"},{"type":"type","title":"Genserver.Protocols.PAutomaticClean.t/0","doc":"","ref":"Genserver.Protocols.PAutomaticClean.html#t:t/0"},{"type":"protocol","title":"Genserver.Protocols.PForcedLoad","doc":"Definition of the function for forced or manual data loading","ref":"Genserver.Protocols.PForcedLoad.html"},{"type":"function","title":"Genserver.Protocols.PForcedLoad.run/2","doc":"Load the data","ref":"Genserver.Protocols.PForcedLoad.html#run/2"},{"type":"function","title":"Parameter: - Genserver.Protocols.PForcedLoad.run/2","doc":"- business: Atom. Business to which the data points.\n\n    - params: List. Other parameters of interest, if needed.","ref":"Genserver.Protocols.PForcedLoad.html#run/2-parameter"},{"type":"type","title":"Genserver.Protocols.PForcedLoad.t/0","doc":"","ref":"Genserver.Protocols.PForcedLoad.html#t:t/0"},{"type":"protocol","title":"Genserver.Protocols.PPostgresDb","doc":"Protocol oriented to load data from a table in a database in postgres","ref":"Genserver.Protocols.PPostgresDb.html"},{"type":"function","title":"Genserver.Protocols.PPostgresDb.perform/3","doc":"Extracts the new information from a certain table and stores it in Bigquery","ref":"Genserver.Protocols.PPostgresDb.html#perform/3"},{"type":"function","title":"Parameter: - Genserver.Protocols.PPostgresDb.perform/3","doc":"- business: Atom. Business to which the data points.\n\n    - conn_odbc_pid: Process. Process connecting Elixir and ODBC.\n\n    - batch_id: String. Batch identifier.","ref":"Genserver.Protocols.PPostgresDb.html#perform/3-parameter"},{"type":"type","title":"Genserver.Protocols.PPostgresDb.t/0","doc":"","ref":"Genserver.Protocols.PPostgresDb.html#t:t/0"},{"type":"protocol","title":"Genserver.Protocols.PWorker","doc":"Protocol oriented to the definition of the function that the message lot will take, processed it if necessary and sent it to the corresponding module, for processing","ref":"Genserver.Protocols.PWorker.html"},{"type":"function","title":"Genserver.Protocols.PWorker.perform/4","doc":"Sends to process the batch of messages, according to the business from which it comes","ref":"Genserver.Protocols.PWorker.html#perform/4"},{"type":"function","title":"Parameters: - Genserver.Protocols.PWorker.perform/4","doc":"- batch: List of map. Payloads.\n\n    - batch_id: String. Batch identifier.\n\n    - conn_odbc_pid: Process. Process connecting Elixir and ODBC.\n\n    - business: Atom. Business type.","ref":"Genserver.Protocols.PWorker.html#perform/4-parameters"},{"type":"type","title":"Genserver.Protocols.PWorker.t/0","doc":"","ref":"Genserver.Protocols.PWorker.html#t:t/0"},{"type":"module","title":"Genserver.RabbitConsumerByBatch","doc":"Batch-oriented genserver of rabbit queues\n\nFor the correct operation, you must implement the Genserver.utils.pWorker protocol","ref":"Genserver.RabbitConsumerByBatch.html"},{"type":"function","title":"Genserver.RabbitConsumerByBatch.handle_info/2","doc":"","ref":"Genserver.RabbitConsumerByBatch.html#handle_info/2"},{"type":"function","title":"Genserver.RabbitConsumerByBatch.init/1","doc":"","ref":"Genserver.RabbitConsumerByBatch.html#init/1"},{"type":"function","title":"Genserver.RabbitConsumerByBatch.start_link/1","doc":"","ref":"Genserver.RabbitConsumerByBatch.html#start_link/1"},{"type":"module","title":"Notification.Notify","doc":"Module responsible for sending notifications to other spaces: Slack, Email, etc.","ref":"Notification.Notify.html"},{"type":"function","title":"Notification.Notify.notify_slack/4","doc":"Sends a message to Slack, splitting it into chunks of up to 3000 characters.","ref":"Notification.Notify.html#notify_slack/4"},{"type":"function","title":"Parameters: - Notification.Notify.notify_slack/4","doc":"- url: String. The Slack webhook URL.\n    - headers: List. The HTTP headers for the request.\n    - env: String. The environment where the message is sent from.\n    - info: String. The message content to be sent.","ref":"Notification.Notify.html#notify_slack/4-parameters"},{"type":"function","title":"Notification.Notify.notify_slack/5","doc":"Send notifications to Slack","ref":"Notification.Notify.html#notify_slack/5"},{"type":"function","title":"Parameter: - Notification.Notify.notify_slack/5","doc":"- url: String. Url to send the notification.\n\n    - headers: List.\n\n    - env: String.\n\n    - msg: Map.\n\n    - error: Exception.","ref":"Notification.Notify.html#notify_slack/5-parameter"},{"type":"module","title":"Statement.Elastic","doc":"Module oriented to the creation of queries to Elastic","ref":"Statement.Elastic.html"},{"type":"function","title":"Statement.Elastic.build_query/1","doc":"Returns the most generic query possible: all nodes with their indexed terms","ref":"Statement.Elastic.html#build_query/1"},{"type":"function","title":"Parameter: - Statement.Elastic.build_query/1","doc":"- size: Integer. Number of records to return.","ref":"Statement.Elastic.html#build_query/1-parameter"},{"type":"function","title":"Return: - Statement.Elastic.build_query/1","doc":"- String","ref":"Statement.Elastic.html#build_query/1-return"},{"type":"function","title":"Statement.Elastic.build_query/6","doc":"Returns a query, where it is defined to return only an indexed field, filters those such that the field deleted=false and a certain field is in a range","ref":"Statement.Elastic.html#build_query/6"},{"type":"function","title":"Parameters: - Statement.Elastic.build_query/6","doc":"- index_to_return: String. Indexed field that will only contain the response.\n\n    - index_for_range: String. indexed field that will be used to establish a search range.\n\n    - lower_bound: String. Lower bound of the range.\n\n    - upper_bound: String. Upper bound of the range.\n\n    - from: Integer. Position, after obtaining the ordered response, by which the values to be displayed will begin to be taken.\n\n    - size: Integer. Amount of values to take, after the defined position.","ref":"Statement.Elastic.html#build_query/6-parameters"},{"type":"function","title":"Return: - Statement.Elastic.build_query/6","doc":"- String","ref":"Statement.Elastic.html#build_query/6-return"},{"type":"function","title":"Statement.Elastic.build_query_inside/3","doc":"Returns a query that will be used within another. Particular case for the New Vehicles service","ref":"Statement.Elastic.html#build_query_inside/3"},{"type":"function","title":"Parameters: - Statement.Elastic.build_query_inside/3","doc":"- index_for_range: String. indexed field that will be used to establish a search range.\n\n    - lower_bound: String. Lower bound of the range.\n\n    - upper_bound: String. Upper bound of the range.","ref":"Statement.Elastic.html#build_query_inside/3-parameters"},{"type":"function","title":"Return: - Statement.Elastic.build_query_inside/3","doc":"- String","ref":"Statement.Elastic.html#build_query_inside/3-return"},{"type":"module","title":"Statement.Sql","doc":"Module for definition and construction of SQL statements","ref":"Statement.Sql.html"},{"type":"function","title":"Statement.Sql.delete/1","doc":"Construct an DELETE statement","ref":"Statement.Sql.html#delete/1"},{"type":"function","title":"Parameters: - Statement.Sql.delete/1","doc":"- table_id: String. Name of the table.\n\n    - conditions. List of (list of tuple). If the value is a empty list, it will be assumed that the existence of the WHERE component is not desired. Otherwise, each tuple has the format {a, b, c} or {a, b, c, d} where\n\n        - a: Atom. Column name.\n\n        - b: t(). Value to compare.\n\n        - c: Atom. Operation to use. Expect :eq, :eq_nil, :neq, :neq_nil, :gt, :gte, :lt, :lte, :in, :like. You can query get_operator/1.\n\n        - d: Atom. Function to use.\n\n    Each list of this parameter, its elements are concatenated by the first value defined in `operators` and the lists are related to each other by the second value defined in `operators`.\n\n    - operators: List of size at most 2. List of connectors. if it has cardinality\n\n        - 0 => length(conditions) = 0\n\n        - 1 => length(conditions) = 1\n\n        - 2 => length(conditions) > 1","ref":"Statement.Sql.html#delete/1-parameters"},{"type":"function","title":"Return: - Statement.Sql.delete/1","doc":"- String","ref":"Statement.Sql.html#delete/1-return"},{"type":"function","title":"Statement.Sql.delete/3","doc":"","ref":"Statement.Sql.html#delete/3"},{"type":"function","title":"Statement.Sql.generate_uuid/0","doc":"Construct an instruction to generate a UUID","ref":"Statement.Sql.html#generate_uuid/0"},{"type":"function","title":"Return: - Statement.Sql.generate_uuid/0","doc":"- String","ref":"Statement.Sql.html#generate_uuid/0-return"},{"type":"function","title":"Statement.Sql.get_function/1","doc":"Returns the known SQL function","ref":"Statement.Sql.html#get_function/1"},{"type":"function","title":"Parameter: - Statement.Sql.get_function/1","doc":"- function_name: Atom. Name of SQL function to use. The possible values are:\n        :timestamp  Function returns a datetime value based on a date or datetime value string, contains a time zone.\n        :datetime   Function returns a datetime value based on a date or datetime value string\n        :time       Function returns a time value based on a date or time value string\n        :date       Function returns a time value based on a date or date value string","ref":"Statement.Sql.html#get_function/1-parameter"},{"type":"function","title":"Return: - Statement.Sql.get_function/1","doc":"- String","ref":"Statement.Sql.html#get_function/1-return"},{"type":"function","title":"Statement.Sql.get_operator/1","doc":"Returns the concatenation operator. The `BETWEEN` operator is not expected.","ref":"Statement.Sql.html#get_operator/1"},{"type":"function","title":"Parameter: - Statement.Sql.get_operator/1","doc":"- operator: Atom. Operator to convert. The possible values are:\n        :eq     =       equal\n        :neq    <>      not equal\n        :gt     >       greater than\n        :gte    >=      greater than or equal\n        :lt     <       less than\n        :lte    <=      less than or equal\n        :like   LIKE    search for a pattern\n        :in     IN      to specify multiple possible values for a column\n        :and    AND     and\n        :or     OR      or\n        :on     ON      to join\n\n        :inner_join     INNER JOIN          returns records that have matching values in both tables\n        :left_join      LEFT OUTER JOIN     returns all records from the left table, and the matched records from the right table\n        :right_join     RIGHT OUTER JOIN    returns all records from the right table, and the matched records from the left table\n        :full_join      FULL OUTER JOIN     returns all records when there is a match in either left or right table","ref":"Statement.Sql.html#get_operator/1-parameter"},{"type":"function","title":"Return: - Statement.Sql.get_operator/1","doc":"- String","ref":"Statement.Sql.html#get_operator/1-return"},{"type":"function","title":"Statement.Sql.insert/2","doc":"Construct an INSERT statement","ref":"Statement.Sql.html#insert/2"},{"type":"function","title":"Parameters: - Statement.Sql.insert/2","doc":"- table_id: String. Name of the table to insert the data into.\n\n    - values: List of tuples. List of values to insert. Each tuple is {column_name, associated_value_to_store}.","ref":"Statement.Sql.html#insert/2-parameters"},{"type":"function","title":"Return: - Statement.Sql.insert/2","doc":"- String","ref":"Statement.Sql.html#insert/2-return"},{"type":"function","title":"Statement.Sql.merge_inserts/1","doc":"Combine multiple `INSERT` queries into a single one","ref":"Statement.Sql.html#merge_inserts/1"},{"type":"function","title":"Parameters: - Statement.Sql.merge_inserts/1","doc":"- `queries`: [String]. List of insert clauses. It is assumed that they all belong to the same table","ref":"Statement.Sql.html#merge_inserts/1-parameters"},{"type":"function","title":"Return: - Statement.Sql.merge_inserts/1","doc":"- String","ref":"Statement.Sql.html#merge_inserts/1-return"},{"type":"function","title":"Statement.Sql.select/4","doc":"Construct an SELECT statement","ref":"Statement.Sql.html#select/4"},{"type":"function","title":"Parameters: - Statement.Sql.select/4","doc":"- table_id: String. Name of the table.\n\n    - columns_to_return: List of atoms | :all. Defines the columns to return. If the `all` atom is defined, all the columns of the table will be returned; otherwise, a list will be defined with those that interest\n\n    - conditions. List of (list of tuple). If the value is a empty list, it will be assumed that the existence of the WHERE component is not desired. Otherwise, each tuple has the format {a, b, c} or {a, b, c, d} where\n\n        - a: Atom. Column name.\n\n        - b: t(). Value to compare.\n\n        - c: Atom. Operation to use. Expect :eq, :eq_nil, :neq, :neq_nil, :gt, :gte, :lt, :lte, :in, :like. You can query get_operator/1.\n\n        - d: Atom. Function to use.\n\n    Each list of this parameter, its elements are concatenated by the first value defined in `operators` and the lists are related to each other by the second value defined in `operators`.\n\n    - operators: List of size at most 2. List of connectors. if it has cardinality\n\n        - 0 => length(conditions) = 0\n\n        - 1 => length(conditions) = 1\n\n        - 2 => length(conditions) > 1","ref":"Statement.Sql.html#select/4-parameters"},{"type":"function","title":"Return: - Statement.Sql.select/4","doc":"- String","ref":"Statement.Sql.html#select/4-return"},{"type":"function","title":"Statement.Sql.update/4","doc":"Construct an UPDATE statement","ref":"Statement.Sql.html#update/4"},{"type":"function","title":"Parameters: - Statement.Sql.update/4","doc":"- table_id: String. Name of the table.\n\n    - changes: List of tuple of size 2 [{atom, t()}, ...]. Change list. Each tuple {A, B} indicates\n\n        - A field to modify\n\n        - B value to modify in field a\n\n    - conditions. List of (list of tuple). If the value is a empty list, it will be assumed that the existence of the WHERE component is not desired. Otherwise, each tuple has the format {a, b, c} or {a, b, c, d} where\n\n        - a: Atom. Column name.\n\n        - b: t(). Value to compare.\n\n        - c: Atom. Operation to use. Expect :eq, :eq_nil, :neq, :neq_nil, :gt, :gte, :lt, :lte, :in, :like. You can query get_operator/1.\n\n        - d: Atom. Function to use.\n\n    Each list of this parameter, its elements are concatenated by the first value defined in `operators` and the lists are related to each other by the second value defined in `operators`.\n\n    - operators: List of size at most 2. List of connectors. if it has cardinality\n\n        - 0 => length(conditions) = 0\n\n        - 1 => length(conditions) = 1\n\n        - 2 => length(conditions) > 1","ref":"Statement.Sql.html#update/4-parameters"},{"type":"function","title":"Return: - Statement.Sql.update/4","doc":"- String","ref":"Statement.Sql.html#update/4-return"},{"type":"module","title":"Struct.InfoAttr","doc":"Definition of the attributes belonging to each table and link with the payload.\nThe payload is assumed to be in `map` format.","ref":"Struct.InfoAttr.html"},{"type":"module","title":"Fields: - Struct.InfoAttr","doc":"- id: Atom. Name of the attribute in the database.\n\n    - id_payload: String. Name of the associated attribute, defined in the payload.\n\n    - type: Atom. Value type of attribute in the database.\n\n    - keys_to_search: List of String. Keys to search in each level of the map.\n\n    - default_value: Default value.","ref":"Struct.InfoAttr.html#module-fields"},{"type":"module","title":"Stuff","doc":"Useful functions","ref":"Stuff.html"},{"type":"function","title":"Stuff.convert_seconds_to_humans/1","doc":"Converts a time in seconds to the understandable format hh:mm:ss\n\n###Parameter:\n\n    - time: Integer. Time in second.","ref":"Stuff.html#convert_seconds_to_humans/1"},{"type":"function","title":"Return: - Stuff.convert_seconds_to_humans/1","doc":"- String","ref":"Stuff.html#convert_seconds_to_humans/1-return"},{"type":"function","title":"Stuff.get_firsts/2","doc":"Takes the first elements of the list","ref":"Stuff.html#get_firsts/2"},{"type":"function","title":"Parameters: - Stuff.get_firsts/2","doc":"- list: List. List.\n\n    - n: Integer. Number of elements to be taken consecutively, starting with the first.","ref":"Stuff.html#get_firsts/2-parameters"},{"type":"function","title":"Return: - Stuff.get_firsts/2","doc":"- {A, B} (A + B = list) where\n\n        A List the first `n` elements of `list`\n\n        B List of the remaining elements of `list`","ref":"Stuff.html#get_firsts/2-return"},{"type":"function","title":"Stuff.integer_to_string_with_2_digits/1","doc":"Converts a number to a string, with the particularity that if the number is one digit, it adds the zero before it","ref":"Stuff.html#integer_to_string_with_2_digits/1"},{"type":"function","title":"Parameter: - Stuff.integer_to_string_with_2_digits/1","doc":"- n: Integer. Number to convert.","ref":"Stuff.html#integer_to_string_with_2_digits/1-parameter"},{"type":"function","title":"Return: - Stuff.integer_to_string_with_2_digits/1","doc":"- String.","ref":"Stuff.html#integer_to_string_with_2_digits/1-return"},{"type":"function","title":"Stuff.list_subtraction/2","doc":"Subtract between lists. It generalizes, and uses, the one implemented by Kernel.--/2.\nThe difference is for when a term to \"subtract\" is a map; in this case its values are obtained and it is transformed into lists of tuples, applying the subtraction to them.","ref":"Stuff.html#list_subtraction/2"},{"type":"function","title":"Parameters: - Stuff.list_subtraction/2","doc":"- l1: List of tuples of size 2. List of items.\n\n    - l2: List of tuples of size 2. List of elements used to compare in `l1`. Those tuples that are the same are removed from `l1`.","ref":"Stuff.html#list_subtraction/2-parameters"},{"type":"function","title":"Return: - Stuff.list_subtraction/2","doc":"- List of tuples of size 2","ref":"Stuff.html#list_subtraction/2-return"},{"type":"function","title":"Stuff.random_string_generate/1","doc":"Generates a random string with the symbols '0123456789abcdefghijklmnopqrstuvwxyz'","ref":"Stuff.html#random_string_generate/1"},{"type":"function","title":"Parameter: - Stuff.random_string_generate/1","doc":"- len: Integer. Chain length.","ref":"Stuff.html#random_string_generate/1-parameter"},{"type":"function","title":"Return: - Stuff.random_string_generate/1","doc":"- String.","ref":"Stuff.html#random_string_generate/1-return"},{"type":"protocol","title":"Time.PWorkingTimeForBusiness","doc":"Module oriented to the specification of each business with its schedules","ref":"Time.PWorkingTimeForBusiness.html"},{"type":"function","title":"Time.PWorkingTimeForBusiness.is_working_day?/3","doc":"Check if the defined date is a working day","ref":"Time.PWorkingTimeForBusiness.html#is_working_day?/3"},{"type":"function","title":"Parameters: - Time.PWorkingTimeForBusiness.is_working_day?/3","doc":"- date: Timex.DateTime. Date.\n\n    - business: Atom. Business.\n\n    - params: t. Auxiliary parameters.","ref":"Time.PWorkingTimeForBusiness.html#is_working_day?/3-parameters"},{"type":"function","title":"Return: - Time.PWorkingTimeForBusiness.is_working_day?/3","doc":"- Boolean.","ref":"Time.PWorkingTimeForBusiness.html#is_working_day?/3-return"},{"type":"function","title":"Time.PWorkingTimeForBusiness.working_hours/3","doc":"Returns the working hours of a day, given the business","ref":"Time.PWorkingTimeForBusiness.html#working_hours/3"},{"type":"function","title":"Parameters: - Time.PWorkingTimeForBusiness.working_hours/3","doc":"- date: Timex.DateTime. Date.\n\n    - business: Atom. Business.\n\n    - params: t. Auxiliary parameters.","ref":"Time.PWorkingTimeForBusiness.html#working_hours/3-parameters"},{"type":"function","title":"Return: - Time.PWorkingTimeForBusiness.working_hours/3","doc":"- {start_time, end_time}, where each element is {hour, minute, second}","ref":"Time.PWorkingTimeForBusiness.html#working_hours/3-return"},{"type":"type","title":"Time.PWorkingTimeForBusiness.t/0","doc":"","ref":"Time.PWorkingTimeForBusiness.html#t:t/0"},{"type":"module","title":"Time.Timem","doc":"It expands functionalities that Timex library does not present","ref":"Time.Timem.html"},{"type":"function","title":"Time.Timem.by_intervals/3","doc":"Given a date range, construct consecutive non-overlapping intervals","ref":"Time.Timem.html#by_intervals/3"},{"type":"function","title":"Parameters: - Time.Timem.by_intervals/3","doc":"- start_date: Timex.DateTime. Interval start date.\n\n    - end_date: Timex.DateTime. End date of the interval.\n\n    -step: Integer. Number of days covered by a subinterval.","ref":"Time.Timem.html#by_intervals/3-parameters"},{"type":"function","title":"Returns: - Time.Timem.by_intervals/3","doc":"- {:error, Atom (reason)} | {:ok, [{Timex.DateTime, Timex.DateTime}, ...]}","ref":"Time.Timem.html#by_intervals/3-returns"},{"type":"function","title":"Time.Timem.get_date_with_string_format/0","doc":"Returns the current time in YYYY-MM-DDformat","ref":"Time.Timem.html#get_date_with_string_format/0"},{"type":"function","title":"Return: - Time.Timem.get_date_with_string_format/0","doc":"- String","ref":"Time.Timem.html#get_date_with_string_format/0-return"},{"type":"function","title":"Time.Timem.get_time_with_string_format/0","doc":"Returns the current date in HH:MM:SS format","ref":"Time.Timem.html#get_time_with_string_format/0"},{"type":"function","title":"Return: - Time.Timem.get_time_with_string_format/0","doc":"- String","ref":"Time.Timem.html#get_time_with_string_format/0-return"},{"type":"function","title":"Time.Timem.is_holiday?/1","doc":"Determine given the month and day, if it is a holiday","ref":"Time.Timem.html#is_holiday?/1"},{"type":"function","title":"Parameter: - Time.Timem.is_holiday?/1","doc":"- date: Timex.DateTime.\n\n# Return:\n\n    - boolean. True if day is a holiday, false otherwise.","ref":"Time.Timem.html#is_holiday?/1-parameter"},{"type":"function","title":"Time.Timem.notification_frequency/1","doc":"Search the time defined in the configuration, for sending notifications","ref":"Time.Timem.html#notification_frequency/1"},{"type":"function","title":"Parameter: - Time.Timem.notification_frequency/1","doc":"- info. Map. Information about the time. It is expected to have the format\n        ```%{\n            day: value_0,\n            hours: value_1,\n            minute: value_2,\n            second: value_3,\n        }\n        ```\n        If no time measurement is found or they are invalid, it will be taken as 0.","ref":"Time.Timem.html#notification_frequency/1-parameter"},{"type":"function","title":"Return: - Time.Timem.notification_frequency/1","doc":"- Integer. Time in milliseconds. The smallest possible return value is 1000 (1 second).","ref":"Time.Timem.html#notification_frequency/1-return"},{"type":"module","title":"Time.WorkingTime","doc":"Module oriented to the calculation of working time, according to the business","ref":"Time.WorkingTime.html"},{"type":"function","title":"Time.WorkingTime.convert_to_business_datetime/4","doc":"Given a date, it returns the next date such that it is skilled in the defined working hours. Can return the same date.","ref":"Time.WorkingTime.html#convert_to_business_datetime/4"},{"type":"function","title":"Parameter: - Time.WorkingTime.convert_to_business_datetime/4","doc":"- date: DateTime. Date.\n\n    - business: Atom. Business.\n\n    - params: t. Auxiliary parameters.\n\n    - change_timezone: Boolean. Indicate if you have to change the dates to the time use defined in the configuration.","ref":"Time.WorkingTime.html#convert_to_business_datetime/4-parameter"},{"type":"function","title":"Return: - Time.WorkingTime.convert_to_business_datetime/4","doc":"- DateTime","ref":"Time.WorkingTime.html#convert_to_business_datetime/4-return"},{"type":"function","title":"Time.WorkingTime.elapsed_time/5","doc":"Calculates the working time elapsed between two dates. Depending on the business, hours vary.\n\nTo add a new business and its particular hours, you must:\n    1. Define a module with the name of the business.\n    2. Implement the Time.PWorkingTimeForBusiness protocol, to define particular hours. Use the following template:\n\n    ```\n    define Time.PWorkingTimeForBusiness, for: Atom do\n        def function_name(date,  ) do\n            ...\n        end\n\n        ...\n\n    end\n    ```","ref":"Time.WorkingTime.html#elapsed_time/5"},{"type":"function","title":"Parameter: - Time.WorkingTime.elapsed_time/5","doc":"- start_date: Timex.DateTime or String. Start date.\n\n    - end_date: Timex.DateTime or String. End date.\n\n    - business: Atom. Business.\n\n    - params: t. Auxiliary parameters.\n\n    - change_timezone: Boolean. Indicate if you have to change the dates to the time use defined in the configuration.","ref":"Time.WorkingTime.html#elapsed_time/5-parameter"},{"type":"function","title":"Return: - Time.WorkingTime.elapsed_time/5","doc":"- {:ok, Integer (seconds)} | {:error, String}","ref":"Time.WorkingTime.html#elapsed_time/5-return"},{"type":"module","title":"Tools.SystemStats","doc":"Module to retrieve system memory usage and disk usage information in a human-readable format.","ref":"Tools.SystemStats.html"},{"type":"function","title":"Tools.SystemStats.get_disk_info/0","doc":"Gets the system's disk usage in a human-readable format.","ref":"Tools.SystemStats.html#get_disk_info/0"},{"type":"function","title":"Returns: - Tools.SystemStats.get_disk_info/0","doc":"- Map containing `:used` and `:free` disk space in human-readable format.","ref":"Tools.SystemStats.html#get_disk_info/0-returns"},{"type":"function","title":"Tools.SystemStats.get_memory_info/0","doc":"Gets the system's memory usage in a human-readable format (KB, MB, GB).","ref":"Tools.SystemStats.html#get_memory_info/0"},{"type":"function","title":"Returns: - Tools.SystemStats.get_memory_info/0","doc":"- Map with `:used` and `:free` keys containing the memory usage in a human-readable format.","ref":"Tools.SystemStats.html#get_memory_info/0-returns"},{"type":"protocol","title":"Type.PConvertTo","doc":"Protocol oriented to the definition of the function to convert from one data type to another","ref":"Type.PConvertTo.html"},{"type":"function","title":"Type.PConvertTo.convert_to/2","doc":"Converts a value to the equivalent of the defined type","ref":"Type.PConvertTo.html#convert_to/2"},{"type":"function","title":"Parameters: - Type.PConvertTo.convert_to/2","doc":"-x:t(). Value.\n\n    - type: Atom. Data type to convert.","ref":"Type.PConvertTo.html#convert_to/2-parameters"},{"type":"function","title":"Return: - Type.PConvertTo.convert_to/2","doc":"- type()","ref":"Type.PConvertTo.html#convert_to/2-return"},{"type":"type","title":"Type.PConvertTo.t/0","doc":"","ref":"Type.PConvertTo.html#t:t/0"},{"type":"protocol","title":"Type.PDocumentaryTypeOf","doc":"Protocol for the work of documentaries in NodeService","ref":"Type.PDocumentaryTypeOf.html"},{"type":"function","title":"Type.PDocumentaryTypeOf.documentary_type_of/1","doc":"Returns the type of documentary, given the business","ref":"Type.PDocumentaryTypeOf.html#documentary_type_of/1"},{"type":"function","title":"Parameter: - Type.PDocumentaryTypeOf.documentary_type_of/1","doc":"- business: String. Business.","ref":"Type.PDocumentaryTypeOf.html#documentary_type_of/1-parameter"},{"type":"function","title":"Return: - Type.PDocumentaryTypeOf.documentary_type_of/1","doc":"- String","ref":"Type.PDocumentaryTypeOf.html#documentary_type_of/1-return"},{"type":"type","title":"Type.PDocumentaryTypeOf.t/0","doc":"","ref":"Type.PDocumentaryTypeOf.html#t:t/0"},{"type":"protocol","title":"Type.PTypeOf","doc":"Protocol oriented to determine the data type of an object","ref":"Type.PTypeOf.html"},{"type":"function","title":"Type.PTypeOf.type_of/1","doc":"Determine the type of data","ref":"Type.PTypeOf.html#type_of/1"},{"type":"function","title":"Parameter: - Type.PTypeOf.type_of/1","doc":"- data. t(): Data.","ref":"Type.PTypeOf.html#type_of/1-parameter"},{"type":"function","title":"Return: - Type.PTypeOf.type_of/1","doc":"- Atom.","ref":"Type.PTypeOf.html#type_of/1-return"},{"type":"function","title":"Examples: - Type.PTypeOf.type_of/1","doc":"iex> Type.type_of(1)\n    :integer\n\n    iex> Type.type_of(%{hello: \"world\"})\n    :map\n\n    iex> tmp = \"string\"\n    iex> Type.type_of(tmp)\n    :binary","ref":"Type.PTypeOf.html#type_of/1-examples"},{"type":"type","title":"Type.PTypeOf.t/0","doc":"","ref":"Type.PTypeOf.html#t:t/0"},{"type":"module","title":"Type.Type","doc":"Module for working with data types","ref":"Type.Type.html"},{"type":"function","title":"Type.Type.convert/2","doc":"Converts a data to its equivalent of a defined type","ref":"Type.Type.html#convert/2"},{"type":"function","title":"Parameters: - Type.Type.convert/2","doc":"- x. Data to convert.\n\n    - to: Data type that `x` will be converted to.","ref":"Type.Type.html#convert/2-parameters"},{"type":"function","title":"Return: - Type.Type.convert/2","doc":"- value | nil | Exception","ref":"Type.Type.html#convert/2-return"},{"type":"function","title":"Examples: - Type.Type.convert/2","doc":"iex> Type.convert(2, :float)\n    2.0\n\n    iex> Type.convert(\"2\", :integer)\n    2\n\n    iex>Type.convert(\"14\", :integer)\n    14Type.convert(\"chain\", :map)\n\n    iex> Type.convert(\"chain\", :string)\n    \"chain\"\n\n    iex> Type.convert(\"chain\", :map)\n    (throw) \"NotImplementedError => from `binary` to `map`\"\n\n    iex> Type.convert(1668036600542, :string_datetime)\n    \"2022-11-09T23:30:00.542Z\"","ref":"Type.Type.html#convert/2-examples"},{"type":"function","title":"Special considerations: - Type.Type.convert/2","doc":"- Elixir built-in data types to work with: binary, nil, integer, float, atom, list, map, boolean.\n\n    - Elixir's non-built-in data types to work with: DateTime\n\n    - Elixir non-existent data types, but need to create its name:\n\n        - string: Binary equivalent.\n\n        - string_datetime: Equivalent to converting from an integer to a binary, in DateTime format.","ref":"Type.Type.html#convert/2-special-considerations"},{"type":"function","title":"Type.Type.convert_for_bigquery/1","doc":"Converts the data into a format understandable by BigQuery","ref":"Type.Type.html#convert_for_bigquery/1"},{"type":"function","title":"Parameter: - Type.Type.convert_for_bigquery/1","doc":"- x: t(). Value.","ref":"Type.Type.html#convert_for_bigquery/1-parameter"},{"type":"function","title":"Return: - Type.Type.convert_for_bigquery/1","doc":"- String","ref":"Type.Type.html#convert_for_bigquery/1-return"},{"type":"function","title":"Type.Type.convert_from_bigquery/1","doc":"Convert bigquery text to understandable format","ref":"Type.Type.html#convert_from_bigquery/1"},{"type":"function","title":"Parameter: - Type.Type.convert_from_bigquery/1","doc":"- x: t(). Value.","ref":"Type.Type.html#convert_from_bigquery/1-parameter"},{"type":"function","title":"Return: - Type.Type.convert_from_bigquery/1","doc":"- String","ref":"Type.Type.html#convert_from_bigquery/1-return"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}